Clazz.declarePackage ("jalview.appletgui");
Clazz.load (["awt2swing.Panel", "java.awt.event.ItemListener", "awt2swing.Button", "$.Checkbox", "$.Choice", "java.awt.Font"], "jalview.appletgui.FontChooser", ["awt2swing.Frame", "$.Label", "jalview.appletgui.JVDialog", "jalview.bin.JalviewLite", "jalview.util.MessageManager", "java.awt.BorderLayout", "$.Color", "$.FlowLayout", "$.Toolkit", "java.awt.event.ActionListener"], function () {
c$ = Clazz.decorateAsClass (function () {
this.fontSize = null;
this.fontStyle = null;
this.fontName = null;
this.scaleAsCdna = null;
this.ok = null;
this.cancel = null;
this.ap = null;
this.tp = null;
this.oldFont = null;
this.oldCharWidth = 0;
this.oldScaleProtein = false;
this.lastSelected = null;
this.lastSelStyle = 0;
this.lastSelSize = 0;
this.$init = true;
this.frame = null;
Clazz.instantialize (this, arguments);
}, jalview.appletgui, "FontChooser", awt2swing.Panel, java.awt.event.ItemListener);
Clazz.prepareFields (c$, function () {
this.fontSize =  new awt2swing.Choice ();
this.fontStyle =  new awt2swing.Choice ();
this.fontName =  new awt2swing.Choice ();
this.scaleAsCdna =  new awt2swing.Checkbox ();
this.ok =  new awt2swing.Button ();
this.cancel =  new awt2swing.Button ();
});
Clazz.makeConstructor (c$, 
function (tp) {
Clazz.superConstructor (this, jalview.appletgui.FontChooser, []);
try {
this.jbInit ();
} catch (e) {
if (Clazz.exceptionOf (e, Exception)) {
e.printStackTrace ();
} else {
throw e;
}
}
this.tp = tp;
this.oldFont = tp.getTreeFont ();
this.init ();
}, "jalview.appletgui.TreePanel");
Clazz.makeConstructor (c$, 
function (ap) {
Clazz.superConstructor (this, jalview.appletgui.FontChooser, []);
this.ap = ap;
this.oldFont = ap.av.getFont ();
this.oldCharWidth = ap.av.getViewStyle ().getCharWidth ();
this.oldScaleProtein = ap.av.getViewStyle ().isScaleProteinAsCdna ();
try {
this.jbInit ();
} catch (e) {
if (Clazz.exceptionOf (e, Exception)) {
e.printStackTrace ();
} else {
throw e;
}
}
this.init ();
}, "jalview.appletgui.AlignmentPanel");
Clazz.defineMethod (c$, "init", 
function () {
var fonts = java.awt.Toolkit.getDefaultToolkit ().getFontList ();
for (var i = 0; i < fonts.length; i++) {
this.fontName.addItem (fonts[i]);
}
for (var i = 1; i < 31; i++) {
this.fontSize.addItem (i + "");
}
this.fontStyle.addItem ("plain");
this.fontStyle.addItem ("bold");
this.fontStyle.addItem ("italic");
this.fontName.select (this.oldFont.getName ());
this.fontSize.select (this.oldFont.getSize () + "");
this.fontStyle.select (new Integer (this.oldFont.getStyle ()));
this.frame =  new awt2swing.Frame ();
this.frame.add (this);
jalview.bin.JalviewLite.addFrame (this.frame, jalview.util.MessageManager.getString ("action.change_font"), 440, 115);
this.$init = false;
});
Clazz.overrideMethod (c$, "itemStateChanged", 
function (evt) {
var source = evt.getSource ();
if (source === this.fontName) {
this.fontName_actionPerformed ();
} else if (source === this.fontSize) {
this.fontSize_actionPerformed ();
} else if (source === this.fontStyle) {
this.fontStyle_actionPerformed ();
} else if (source === this.scaleAsCdna) {
this.scaleAsCdna_actionPerformed ();
}}, "java.awt.event.ItemEvent");
Clazz.defineMethod (c$, "ok_actionPerformed", 
function () {
this.frame.setVisible (false);
if (this.ap != null) {
if (this.ap.getOverviewPanel () != null) {
this.ap.getOverviewPanel ().updateOverviewImage ();
}}});
Clazz.defineMethod (c$, "cancel_actionPerformed", 
function () {
if (this.ap != null) {
this.ap.av.setScaleProteinAsCdna (this.oldScaleProtein);
if (this.ap.av.getCodingComplement () != null) {
this.ap.av.getCodingComplement ().setScaleProteinAsCdna (this.oldScaleProtein);
this.ap.alignFrame.getSplitFrame ().repaint ();
}this.ap.av.setFont (this.oldFont);
var style = this.ap.av.getViewStyle ();
if (style.getCharWidth () != this.oldCharWidth) {
style.setCharWidth (this.oldCharWidth);
this.ap.av.setViewStyle (style);
}this.ap.paintAlignment (true);
} else if (this.tp != null) {
this.tp.setTreeFont (this.oldFont);
this.tp.treeCanvas.repaint ();
}this.fontName.select (this.oldFont.getName ());
this.fontSize.select (this.oldFont.getSize () + "");
this.fontStyle.select (new Integer (this.oldFont.getStyle ()));
this.frame.setVisible (false);
});
Clazz.defineMethod (c$, "changeFont", 
function () {
if (this.lastSelected == null) {
this.lastSelected = this.oldFont;
this.lastSelSize = this.oldFont.getSize ();
this.lastSelStyle = this.oldFont.getStyle ();
}var newFont =  new java.awt.Font (this.fontName.getSelectedItem ().toString (), this.fontStyle.getSelectedIndex (), Integer.parseInt (this.fontSize.getSelectedItem ().toString ()));
var fm = this.getGraphics ().getFontMetrics (newFont);
var mw = fm.getStringBounds ("M", this.getGraphics ()).getWidth ();
var iw = fm.getStringBounds ("I", this.getGraphics ()).getWidth ();
if (mw < 1 || iw < 1) {
this.fontName.select (this.lastSelected.getName ());
this.fontStyle.select (new Integer (this.lastSelStyle));
this.fontSize.select ("" + this.lastSelSize);
var d =  new jalview.appletgui.JVDialog (this.frame, jalview.util.MessageManager.getString ("label.invalid_font"), true, 350, 200);
var mp =  new awt2swing.Panel ();
d.cancel.setVisible (false);
mp.setLayout ( new java.awt.FlowLayout ());
mp.add ( new awt2swing.Label ("Font doesn't have letters defined\nso cannot be used\nwith alignment data."));
d.setMainPanel (mp);
d.setVisible (true);
return;
}if (this.tp != null) {
this.tp.setTreeFont (newFont);
} else if (this.ap != null) {
this.ap.av.setFont (newFont);
this.ap.fontChanged ();
}this.lastSelected = newFont;
});
Clazz.defineMethod (c$, "fontName_actionPerformed", 
function () {
if (this.$init) {
return;
}this.changeFont ();
});
Clazz.defineMethod (c$, "fontSize_actionPerformed", 
function () {
if (this.$init) {
return;
}this.changeFont ();
});
Clazz.defineMethod (c$, "fontStyle_actionPerformed", 
function () {
if (this.$init) {
return;
}this.changeFont ();
});
Clazz.defineMethod (c$, "jbInit", 
($fz = function () {
this.setLayout ( new java.awt.BorderLayout ());
this.setBackground (java.awt.Color.white);
var fontLabel =  new awt2swing.Label (jalview.util.MessageManager.getString ("label.font"));
fontLabel.setFont (jalview.appletgui.FontChooser.VERDANA_11PT);
fontLabel.setAlignment (4);
this.fontSize.setFont (jalview.appletgui.FontChooser.VERDANA_11PT);
this.fontSize.addItemListener (this);
this.fontStyle.setFont (jalview.appletgui.FontChooser.VERDANA_11PT);
this.fontStyle.addItemListener (this);
var sizeLabel =  new awt2swing.Label (jalview.util.MessageManager.getString ("label.size"));
sizeLabel.setAlignment (4);
sizeLabel.setFont (jalview.appletgui.FontChooser.VERDANA_11PT);
var styleLabel =  new awt2swing.Label (jalview.util.MessageManager.getString ("label.style"));
styleLabel.setAlignment (4);
styleLabel.setFont (jalview.appletgui.FontChooser.VERDANA_11PT);
this.fontName.setFont (jalview.appletgui.FontChooser.VERDANA_11PT);
this.fontName.addItemListener (this);
this.scaleAsCdna.setLabel (jalview.util.MessageManager.getString ("label.scale_as_cdna"));
this.scaleAsCdna.setFont (jalview.appletgui.FontChooser.VERDANA_11PT);
this.scaleAsCdna.addItemListener (this);
this.scaleAsCdna.setState (this.ap.av.isScaleProteinAsCdna ());
this.ok.setFont (jalview.appletgui.FontChooser.VERDANA_11PT);
this.ok.setLabel (jalview.util.MessageManager.getString ("action.ok"));
this.ok.addActionListener (((Clazz.isClassDefined ("jalview.appletgui.FontChooser$1") ? 0 : jalview.appletgui.FontChooser.$FontChooser$1$ ()), Clazz.innerTypeInstance (jalview.appletgui.FontChooser$1, this, null)));
this.cancel.setFont (jalview.appletgui.FontChooser.VERDANA_11PT);
this.cancel.setLabel (jalview.util.MessageManager.getString ("action.cancel"));
this.cancel.addActionListener (((Clazz.isClassDefined ("jalview.appletgui.FontChooser$2") ? 0 : jalview.appletgui.FontChooser.$FontChooser$2$ ()), Clazz.innerTypeInstance (jalview.appletgui.FontChooser$2, this, null)));
var fontPanel =  new awt2swing.Panel ();
fontPanel.setLayout ( new java.awt.BorderLayout ());
var stylePanel =  new awt2swing.Panel ();
stylePanel.setLayout ( new java.awt.BorderLayout ());
var sizePanel =  new awt2swing.Panel ();
sizePanel.setLayout ( new java.awt.BorderLayout ());
var scalePanel =  new awt2swing.Panel ();
scalePanel.setLayout ( new java.awt.BorderLayout ());
var okCancelPanel =  new awt2swing.Panel ();
var optionsPanel =  new awt2swing.Panel ();
fontPanel.setBackground (java.awt.Color.white);
stylePanel.setBackground (java.awt.Color.white);
sizePanel.setBackground (java.awt.Color.white);
okCancelPanel.setBackground (java.awt.Color.white);
optionsPanel.setBackground (java.awt.Color.white);
fontPanel.add (fontLabel, "West");
fontPanel.add (this.fontName, "Center");
stylePanel.add (styleLabel, "West");
stylePanel.add (this.fontStyle, "Center");
sizePanel.add (sizeLabel, "West");
sizePanel.add (this.fontSize, "Center");
scalePanel.add (this.scaleAsCdna, "Center");
okCancelPanel.add (this.ok, null);
okCancelPanel.add (this.cancel, null);
optionsPanel.add (fontPanel, null);
optionsPanel.add (sizePanel, null);
optionsPanel.add (stylePanel, null);
this.add (optionsPanel, "North");
if (this.ap.alignFrame.getSplitFrame () != null) {
this.add (scalePanel, "Center");
}this.add (okCancelPanel, "South");
}, $fz.isPrivate = true, $fz));
Clazz.defineMethod (c$, "scaleAsCdna_actionPerformed", 
function () {
this.ap.av.setScaleProteinAsCdna (this.scaleAsCdna.getState ());
this.ap.av.getCodingComplement ().setScaleProteinAsCdna (this.scaleAsCdna.getState ());
this.ap.alignFrame.getSplitFrame ().adjustLayout ();
this.ap.paintAlignment (true);
this.ap.alignFrame.getSplitFrame ().repaint ();
});
c$.$FontChooser$1$ = function () {
Clazz.pu$h ();
c$ = Clazz.declareAnonymous (jalview.appletgui, "FontChooser$1", null, java.awt.event.ActionListener);
Clazz.overrideMethod (c$, "actionPerformed", 
function (e) {
this.b$["jalview.appletgui.FontChooser"].ok_actionPerformed ();
}, "java.awt.event.ActionEvent");
c$ = Clazz.p0p ();
};
c$.$FontChooser$2$ = function () {
Clazz.pu$h ();
c$ = Clazz.declareAnonymous (jalview.appletgui, "FontChooser$2", null, java.awt.event.ActionListener);
Clazz.overrideMethod (c$, "actionPerformed", 
function (e) {
this.b$["jalview.appletgui.FontChooser"].cancel_actionPerformed ();
}, "java.awt.event.ActionEvent");
c$ = Clazz.p0p ();
};
c$.VERDANA_11PT = c$.prototype.VERDANA_11PT =  new java.awt.Font ("Verdana", 0, 11);
});
